

Include "data_Rsole.geo";

Mesh.Algorithm = 8;

neqdcond = 10;
lccond = (Pi/2*rcond)/neqdcond;
nl = 5;

Point(1) = {lfix/2,0,0,lccond}; 
Point(2) = {lfix/2+rcond,0,0,lccond}; 
Point(3) = {lfix/2,rcond,0,lccond}; 
Point(4) = {lfix/2-rcond,0,0,lccond}; 
Point(5) = {lfix/2,-rcond,0,lccond}; 
For k In {1:3}
  Circle(k) = {k+1,1,k+2};
EndFor
Circle(4) = {5,1,2};
Line Loop(1) = {1,2,3,4};
Plane Surface(1) = {1};
Transfinite Line {1,2,3,4} = neqdcond+1;
Transfinite Surface {1};
Recombine Surface {1};

sin = 1;
vres[] = {};
out[] = Extrude{0,0,pfix-2*rcond} { 
  Surface{sin}; Layers{nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{{0,1,0}, {lfix/2+2*rcond,0,pfix-2*rcond}, Pi/2} { 
  Surface{out[0]}; Layers{2*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{(Lres-lfix)/2-2*rcond,0,0} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{{0,1,0}, {lfix/2+(Lres-lfix)/2,0,pfix+2*rcond}, -Pi/2} { 
  Surface{out[0]}; Layers{2*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{0,0,Pres-4*rcond} { 
  Surface{out[0]}; Layers{5*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{{0,1,0}, {lfix/2+(Lres-lfix)/2,0,Pres-2*rcond+pfix}, -2*Pi/3} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{-(Lres-lfix)/2,0,-(Lres-lfix)/2*Tan(Pi/6)} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]};

zc = pfix+Pres-(Lres-lfix)/2*Tan(Pi/6)+6.5*rcond;
out[] = Extrude{{0,1,0}, {0,0,zc}, Pi/3} { 
  Surface{out[0]}; Layers{2*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{-(Lres-lfix)/2,0,(Lres-lfix)/2*Tan(Pi/6)} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]};

out[] = Extrude{{0,1,0}, {-lfix/2-(Lres-lfix)/2,0,Pres-2*rcond+pfix}, -2*Pi/3} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{0,0,-(Pres-4*rcond)} { 
  Surface{out[0]}; Layers{5*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{{0,1,0}, {-lfix/2-(Lres-lfix)/2,0,pfix+2*rcond}, -Pi/2} { 
  Surface{out[0]}; Layers{2*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{(Lres-lfix)/2-2*rcond,0,0} { 
  Surface{out[0]}; Layers{3*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{{0,1,0}, {-lfix/2-2*rcond,0,pfix-2*rcond}, Pi/2} { 
  Surface{out[0]}; Layers{2*nl}; Recombine;};
vres[] += {out[1]}; 

out[] = Extrude{0,0,-(pfix-2*rcond)} { 
  Surface{out[0]}; Layers{nl}; Recombine;};
vres[] += {out[1]}; 

sout = out[0];

Physical Volume(CONDUCTEUR) = {vres[]};
Physical Surface(SENTREE) = {sin};
Physical Surface(SSORTIE) = {sout};

Color DarkGray {Volume{vres[]};}